Index: branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive/3.4/ServiceClients/HiveServiceClient.cs
===================================================================
--- branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive/3.4/ServiceClients/HiveServiceClient.cs	(revision 6458)
+++ branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive/3.4/ServiceClients/HiveServiceClient.cs	(revision 6463)
@@ -214,4 +214,5 @@
     [System.Runtime.Serialization.KnownTypeAttribute(typeof(HeuristicLab.Clients.Hive.SlaveGroup))]
     [System.Runtime.Serialization.KnownTypeAttribute(typeof(HeuristicLab.Clients.Hive.Plugin))]
+    [System.Runtime.Serialization.KnownTypeAttribute(typeof(HeuristicLab.Clients.Hive.HiveExperimentPermission))]
     [System.Runtime.Serialization.KnownTypeAttribute(typeof(HeuristicLab.Clients.Hive.PluginData))]
     [System.Runtime.Serialization.KnownTypeAttribute(typeof(HeuristicLab.Clients.Hive.LightweightJob))]
@@ -606,4 +607,7 @@
         
         [System.Runtime.Serialization.OptionalFieldAttribute()]
+        private HeuristicLab.Clients.Hive.Permission PermissionField;
+        
+        [System.Runtime.Serialization.OptionalFieldAttribute()]
         private string ResourceNamesField;
         
@@ -706,4 +710,21 @@
                     this.OwnerUserIdField = value;
                     this.RaisePropertyChanged("OwnerUserId");
+                }
+            }
+        }
+        
+        [System.Runtime.Serialization.DataMemberAttribute()]
+        public HeuristicLab.Clients.Hive.Permission Permission
+        {
+            get
+            {
+                return this.PermissionField;
+            }
+            set
+            {
+                if ((this.PermissionField.Equals(value) != true))
+                {
+                    this.PermissionField = value;
+                    this.RaisePropertyChanged("Permission");
                 }
             }
@@ -1088,4 +1109,93 @@
     [System.Diagnostics.DebuggerStepThroughAttribute()]
     [System.CodeDom.Compiler.GeneratedCodeAttribute("System.Runtime.Serialization", "4.0.0.0")]
+    [System.Runtime.Serialization.DataContractAttribute(Name="HiveExperimentPermission", Namespace="http://schemas.datacontract.org/2004/07/HeuristicLab.Services.Hive.Common.DataTra" +
+        "nsfer")]
+    [System.SerializableAttribute()]
+    public partial class HiveExperimentPermission : HeuristicLab.Clients.Hive.HiveItem
+    {
+        
+        [System.Runtime.Serialization.OptionalFieldAttribute()]
+        private System.Guid GrantedByUserIdField;
+        
+        [System.Runtime.Serialization.OptionalFieldAttribute()]
+        private System.Guid GrantedUserIdField;
+        
+        [System.Runtime.Serialization.OptionalFieldAttribute()]
+        private System.Guid HiveExperimentIdField;
+        
+        [System.Runtime.Serialization.OptionalFieldAttribute()]
+        private HeuristicLab.Clients.Hive.Permission PermissionField;
+        
+        [System.Runtime.Serialization.DataMemberAttribute()]
+        public System.Guid GrantedByUserId
+        {
+            get
+            {
+                return this.GrantedByUserIdField;
+            }
+            set
+            {
+                if ((this.GrantedByUserIdField.Equals(value) != true))
+                {
+                    this.GrantedByUserIdField = value;
+                    this.RaisePropertyChanged("GrantedByUserId");
+                }
+            }
+        }
+        
+        [System.Runtime.Serialization.DataMemberAttribute()]
+        public System.Guid GrantedUserId
+        {
+            get
+            {
+                return this.GrantedUserIdField;
+            }
+            set
+            {
+                if ((this.GrantedUserIdField.Equals(value) != true))
+                {
+                    this.GrantedUserIdField = value;
+                    this.RaisePropertyChanged("GrantedUserId");
+                }
+            }
+        }
+        
+        [System.Runtime.Serialization.DataMemberAttribute()]
+        public System.Guid HiveExperimentId
+        {
+            get
+            {
+                return this.HiveExperimentIdField;
+            }
+            set
+            {
+                if ((this.HiveExperimentIdField.Equals(value) != true))
+                {
+                    this.HiveExperimentIdField = value;
+                    this.RaisePropertyChanged("HiveExperimentId");
+                }
+            }
+        }
+        
+        [System.Runtime.Serialization.DataMemberAttribute()]
+        public HeuristicLab.Clients.Hive.Permission Permission
+        {
+            get
+            {
+                return this.PermissionField;
+            }
+            set
+            {
+                if ((this.PermissionField.Equals(value) != true))
+                {
+                    this.PermissionField = value;
+                    this.RaisePropertyChanged("Permission");
+                }
+            }
+        }
+    }
+    
+    [System.Diagnostics.DebuggerStepThroughAttribute()]
+    [System.CodeDom.Compiler.GeneratedCodeAttribute("System.Runtime.Serialization", "4.0.0.0")]
     [System.Runtime.Serialization.DataContractAttribute(Name="PluginData", Namespace="http://schemas.datacontract.org/2004/07/HeuristicLab.Services.Hive.Common.DataTra" +
         "nsfer")]
@@ -1330,4 +1440,20 @@
         [System.Runtime.Serialization.EnumMemberAttribute()]
         Failed = 7,
+    }
+    
+    [System.CodeDom.Compiler.GeneratedCodeAttribute("System.Runtime.Serialization", "4.0.0.0")]
+    [System.Runtime.Serialization.DataContractAttribute(Name="Permission", Namespace="http://schemas.datacontract.org/2004/07/HeuristicLab.Services.Hive.Common.DataTra" +
+        "nsfer")]
+    public enum Permission : int
+    {
+        
+        [System.Runtime.Serialization.EnumMemberAttribute()]
+        NotAllowed = 0,
+        
+        [System.Runtime.Serialization.EnumMemberAttribute()]
+        ReadOnly = 1,
+        
+        [System.Runtime.Serialization.EnumMemberAttribute()]
+        Full = 2,
     }
     
@@ -1783,4 +1909,13 @@
     {
         
+        [System.ServiceModel.OperationContractAttribute(Action="http://tempuri.org/IHiveService/DeleteSlave", ReplyAction="http://tempuri.org/IHiveService/DeleteSlaveResponse")]
+        void DeleteSlave(System.Guid slaveId);
+        
+        [System.ServiceModel.OperationContractAttribute(Action="http://tempuri.org/IHiveService/DeleteSlaveGroup", ReplyAction="http://tempuri.org/IHiveService/DeleteSlaveGroupResponse")]
+        void DeleteSlaveGroup(System.Guid slaveGroupId);
+        
+        [System.ServiceModel.OperationContractAttribute(Action="http://tempuri.org/IHiveService/AddResourceToGroup", ReplyAction="http://tempuri.org/IHiveService/AddResourceToGroupResponse")]
+        void AddResourceToGroup(System.Guid slaveGroupId, System.Guid resourceId);
+        
         [System.ServiceModel.OperationContractAttribute(Action="http://tempuri.org/IHiveService/RemoveResourceFromGroup", ReplyAction="http://tempuri.org/IHiveService/RemoveResourceFromGroupResponse")]
         void RemoveResourceFromGroup(System.Guid slaveGroupId, System.Guid resourceId);
@@ -1807,4 +1942,10 @@
         System.Collections.Generic.List<HeuristicLab.Clients.Hive.Downtime> GetDowntimesForResource(System.Guid resourceId);
         
+        [System.ServiceModel.OperationContractAttribute(Action="http://tempuri.org/IHiveService/GetUsernameByUserId", ReplyAction="http://tempuri.org/IHiveService/GetUsernameByUserIdResponse")]
+        string GetUsernameByUserId(System.Guid userId);
+        
+        [System.ServiceModel.OperationContractAttribute(Action="http://tempuri.org/IHiveService/GetUserIdByUsername", ReplyAction="http://tempuri.org/IHiveService/GetUserIdByUsernameResponse")]
+        System.Guid GetUserIdByUsername(string username);
+        
         [System.ServiceModel.OperationContractAttribute(Action="http://tempuri.org/IHiveService/AddJob", ReplyAction="http://tempuri.org/IHiveService/AddJobResponse")]
         System.Guid AddJob(HeuristicLab.Clients.Hive.Job job, HeuristicLab.Clients.Hive.JobData jobData, System.Collections.Generic.List<System.Guid> resourceIds);
@@ -1872,4 +2013,13 @@
         [System.ServiceModel.OperationContractAttribute(Action="http://tempuri.org/IHiveService/DeleteHiveExperiment", ReplyAction="http://tempuri.org/IHiveService/DeleteHiveExperimentResponse")]
         void DeleteHiveExperiment(System.Guid hiveExperimentId);
+        
+        [System.ServiceModel.OperationContractAttribute(Action="http://tempuri.org/IHiveService/GrantPermission", ReplyAction="http://tempuri.org/IHiveService/GrantPermissionResponse")]
+        void GrantPermission(System.Guid hiveExperimentId, System.Guid grantedUserId, HeuristicLab.Clients.Hive.Permission permission);
+        
+        [System.ServiceModel.OperationContractAttribute(Action="http://tempuri.org/IHiveService/RevokePermission", ReplyAction="http://tempuri.org/IHiveService/RevokePermissionResponse")]
+        void RevokePermission(System.Guid hiveExperimentId, System.Guid grantedUserId);
+        
+        [System.ServiceModel.OperationContractAttribute(Action="http://tempuri.org/IHiveService/GetHiveExperimentPermissions", ReplyAction="http://tempuri.org/IHiveService/GetHiveExperimentPermissionsResponse")]
+        System.Collections.Generic.List<HeuristicLab.Clients.Hive.HiveExperimentPermission> GetHiveExperimentPermissions(System.Guid hiveExperimentId);
         
         [System.ServiceModel.OperationContractAttribute(Action="http://tempuri.org/IHiveService/Hello", ReplyAction="http://tempuri.org/IHiveService/HelloResponse")]
@@ -1924,13 +2074,4 @@
         [System.ServiceModel.OperationContractAttribute(Action="http://tempuri.org/IHiveService/UpdateSlaveGroup", ReplyAction="http://tempuri.org/IHiveService/UpdateSlaveGroupResponse")]
         void UpdateSlaveGroup(HeuristicLab.Clients.Hive.SlaveGroup slaveGroup);
-        
-        [System.ServiceModel.OperationContractAttribute(Action="http://tempuri.org/IHiveService/DeleteSlave", ReplyAction="http://tempuri.org/IHiveService/DeleteSlaveResponse")]
-        void DeleteSlave(System.Guid slaveId);
-        
-        [System.ServiceModel.OperationContractAttribute(Action="http://tempuri.org/IHiveService/DeleteSlaveGroup", ReplyAction="http://tempuri.org/IHiveService/DeleteSlaveGroupResponse")]
-        void DeleteSlaveGroup(System.Guid slaveGroupId);
-        
-        [System.ServiceModel.OperationContractAttribute(Action="http://tempuri.org/IHiveService/AddResourceToGroup", ReplyAction="http://tempuri.org/IHiveService/AddResourceToGroupResponse")]
-        void AddResourceToGroup(System.Guid slaveGroupId, System.Guid resourceId);
     }
     
@@ -1969,4 +2110,19 @@
         }
         
+        public void DeleteSlave(System.Guid slaveId)
+        {
+            base.Channel.DeleteSlave(slaveId);
+        }
+        
+        public void DeleteSlaveGroup(System.Guid slaveGroupId)
+        {
+            base.Channel.DeleteSlaveGroup(slaveGroupId);
+        }
+        
+        public void AddResourceToGroup(System.Guid slaveGroupId, System.Guid resourceId)
+        {
+            base.Channel.AddResourceToGroup(slaveGroupId, resourceId);
+        }
+        
         public void RemoveResourceFromGroup(System.Guid slaveGroupId, System.Guid resourceId)
         {
@@ -2009,4 +2165,14 @@
         }
         
+        public string GetUsernameByUserId(System.Guid userId)
+        {
+            return base.Channel.GetUsernameByUserId(userId);
+        }
+        
+        public System.Guid GetUserIdByUsername(string username)
+        {
+            return base.Channel.GetUserIdByUsername(username);
+        }
+        
         public System.Guid AddJob(HeuristicLab.Clients.Hive.Job job, HeuristicLab.Clients.Hive.JobData jobData, System.Collections.Generic.List<System.Guid> resourceIds)
         {
@@ -2119,4 +2285,19 @@
         }
         
+        public void GrantPermission(System.Guid hiveExperimentId, System.Guid grantedUserId, HeuristicLab.Clients.Hive.Permission permission)
+        {
+            base.Channel.GrantPermission(hiveExperimentId, grantedUserId, permission);
+        }
+        
+        public void RevokePermission(System.Guid hiveExperimentId, System.Guid grantedUserId)
+        {
+            base.Channel.RevokePermission(hiveExperimentId, grantedUserId);
+        }
+        
+        public System.Collections.Generic.List<HeuristicLab.Clients.Hive.HiveExperimentPermission> GetHiveExperimentPermissions(System.Guid hiveExperimentId)
+        {
+            return base.Channel.GetHiveExperimentPermissions(hiveExperimentId);
+        }
+        
         public void Hello(HeuristicLab.Clients.Hive.Slave slave)
         {
@@ -2203,19 +2384,4 @@
             base.Channel.UpdateSlaveGroup(slaveGroup);
         }
-        
-        public void DeleteSlave(System.Guid slaveId)
-        {
-            base.Channel.DeleteSlave(slaveId);
-        }
-        
-        public void DeleteSlaveGroup(System.Guid slaveGroupId)
-        {
-            base.Channel.DeleteSlaveGroup(slaveGroupId);
-        }
-        
-        public void AddResourceToGroup(System.Guid slaveGroupId, System.Guid resourceId)
-        {
-            base.Channel.AddResourceToGroup(slaveGroupId, resourceId);
-        }
     }
 }
Index: branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Services.Hive.Common/3.4/DataTransfer/HiveExperimentPermission.cs
===================================================================
--- branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Services.Hive.Common/3.4/DataTransfer/HiveExperimentPermission.cs	(revision 6458)
+++ branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Services.Hive.Common/3.4/DataTransfer/HiveExperimentPermission.cs	(revision 6463)
@@ -26,5 +26,6 @@
   [DataContract]
   [Serializable]
-  public class HiveExperimentPermission {
+  public class HiveExperimentPermission : HiveItem {
+    // info: this class is derived from HiveItem to simplify handling on the client side, altough it does not have a Id.
     [DataMember]
     public Guid HiveExperimentId { get; set; }
Index: branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Services.Hive.Common/3.4/DataTransfer/Permission.cs
===================================================================
--- branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Services.Hive.Common/3.4/DataTransfer/Permission.cs	(revision 6458)
+++ branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Services.Hive.Common/3.4/DataTransfer/Permission.cs	(revision 6463)
@@ -30,10 +30,5 @@
     /// User can only download and view experiments
     /// </summary>
-    ReadOnly,
-
-    /// <summary>
-    /// User can also  experiments
-    /// </summary>
-    Write,
+    Read,
 
     /// <summary>
Index: branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Services.Hive.Common/3.4/ServiceContracts/IHiveService.cs
===================================================================
--- branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Services.Hive.Common/3.4/ServiceContracts/IHiveService.cs	(revision 6458)
+++ branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Services.Hive.Common/3.4/ServiceContracts/IHiveService.cs	(revision 6463)
@@ -111,6 +111,12 @@
 
     #region HiveExperimentPermission Methods
+    [OperationContract]
     void GrantPermission(Guid hiveExperimentId, Guid grantedUserId, Permission permission);
+
+    [OperationContract]
     void RevokePermission(Guid hiveExperimentId, Guid grantedUserId);
+
+    [OperationContract]
+    IEnumerable<HiveExperimentPermission> GetHiveExperimentPermissions(Guid hiveExperimentId);
     #endregion
 
@@ -205,4 +211,11 @@
     #endregion
 
+    #region User Methods
+    [OperationContract]
+    string GetUsernameByUserId(Guid userId);
+
+    [OperationContract]
+    Guid GetUserIdByUsername(string username);
+    #endregion
   }
 }
Index: branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Services.Hive.Tests/DaoTests.cs
===================================================================
--- branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Services.Hive.Tests/DaoTests.cs	(revision 6458)
+++ branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Services.Hive.Tests/DaoTests.cs	(revision 6463)
@@ -235,5 +235,5 @@
       perm.GrantedByUserId = he.OwnerUserId;
       perm.GrantedUserId = Guid.NewGuid();
-      perm.Permission = Permission.Write;
+      perm.Permission = Permission.Full;
       dao.AddHiveExperimentPermission(perm);
 
Index: branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Services.Hive.Tests/HeuristicLab.Services.Hive-3.4.Tests.csproj
===================================================================
--- branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Services.Hive.Tests/HeuristicLab.Services.Hive-3.4.Tests.csproj	(revision 6458)
+++ branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Services.Hive.Tests/HeuristicLab.Services.Hive-3.4.Tests.csproj	(revision 6463)
@@ -72,4 +72,5 @@
   <ItemGroup>
     <Compile Include="Mocks\MockAuthenticationManager.cs" />
+    <Compile Include="Mocks\MockUserManager.cs" />
     <Compile Include="ServiceTests.cs" />
     <Compile Include="Mocks\MockAuthorizationManager.cs" />
@@ -108,4 +109,5 @@
     <Reference Include="Microsoft.VisualStudio.QualityTools.UnitTestFramework, Version=10.0.0.0, Culture=neutral, PublicKeyToken=b03f5f7f11d50a3a, processorArchitecture=MSIL" />
     <Reference Include="System" />
+    <Reference Include="System.Configuration" />
     <Reference Include="System.Data" />
     <Reference Include="System.Data.DataSetExtensions" />
Index: branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Services.Hive.Tests/Mocks/MockAuthorizationManager.cs
===================================================================
--- branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Services.Hive.Tests/Mocks/MockAuthorizationManager.cs	(revision 6458)
+++ branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Services.Hive.Tests/Mocks/MockAuthorizationManager.cs	(revision 6463)
@@ -24,24 +24,14 @@
 namespace HeuristicLab.Services.Hive.Tests.Mocks {
   public class MockAuthorizationManager : IAuthorizationManager {
-    public static Guid MockUserId1 = new Guid("6C7911A1-46EA-4E51-97DF-5582653AAFCE");
-    public static Guid MockUserId2 = new Guid("897660EB-C90F-4054-988C-D39D530A0A02");
-    public static Guid MockUserId3 = new Guid("9F7B4EA8-A38D-4BC2-802F-E148AC7A6A87");
-
-    private Guid userId = MockUserId1;
-
-    public Guid UserId {
-      get { return userId; }
+    public void Authorize(Guid userId) {
+      // ok.
     }
 
-    public void AuthorizeJobs(params Guid[] jobId) {
-      // o.k.
+    public void AuthorizeForJob(Guid jobId, Common.DataTransfer.Permission requiredPermission) {
+      // ok.
     }
 
-    public void Authorize(Guid userId) {
-      // o.k.
-    }
-    
-    internal void SetUserId(Guid id) {
-      this.userId = id;
+    public void AuthorizeForExperiment(Guid experimentId, Common.DataTransfer.Permission requiredPermission) {
+      // ok.
     }
   }
Index: branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Services.Hive.Tests/Mocks/MockServiceLocator.cs
===================================================================
--- branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Services.Hive.Tests/Mocks/MockServiceLocator.cs	(revision 6458)
+++ branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Services.Hive.Tests/Mocks/MockServiceLocator.cs	(revision 6463)
@@ -20,7 +20,7 @@
 #endregion
 
+using System;
 using HeuristicLab.Services.Hive.DataAccess;
 using HeuristicLab.Services.Hive.Tests.Mocks;
-using System;
 
 namespace HeuristicLab.Services.Hive.Tests {
@@ -36,7 +36,7 @@
     }
 
-    private MockAuthorizationManager mockAuthorizationManager = new MockAuthorizationManager();
+    //private MockAuthorizationManager mockAuthorizationManager = new MockAuthorizationManager();
     public IAuthorizationManager AuthorizationManager {
-      get { return mockAuthorizationManager; }
+      get { return defaultServiceLocator.AuthorizationManager; }
     }
 
@@ -51,5 +51,8 @@
       get { return defaultServiceLocator.TransactionManager; }
     }
-
+    private MockUserManager mockUserManager = new MockUserManager();
+    public IUserManager UserManager {
+      get { return mockUserManager; }
+    }
     public HeartbeatManager HeartbeatManager {
       get { return defaultServiceLocator.HeartbeatManager; }
@@ -57,8 +60,7 @@
 
     #region Special mocking methods
-    public void SetCurrentUser(Guid id) {
-      mockAuthorizationManager.SetUserId(id);
+    public void SetCurrentUserId(Guid userId) {
+      mockUserManager.SetUserId(userId);
     }
-
     #endregion
   }
Index: branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Services.Hive.Tests/Mocks/MockUserManager.cs
===================================================================
--- branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Services.Hive.Tests/Mocks/MockUserManager.cs	(revision 6463)
+++ branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Services.Hive.Tests/Mocks/MockUserManager.cs	(revision 6463)
@@ -0,0 +1,33 @@
+﻿using System;
+using System.Web.Security;
+
+namespace HeuristicLab.Services.Hive.Tests.Mocks {
+  public class MockUserManager : IUserManager {
+    public static Guid MockUserId1 = new Guid("6C7911A1-46EA-4E51-97DF-5582653AAFCE");
+    public static Guid MockUserId2 = new Guid("897660EB-C90F-4054-988C-D39D530A0A02");
+    public static Guid MockUserId3 = new Guid("9F7B4EA8-A38D-4BC2-802F-E148AC7A6A87");
+
+    private Guid currentUserId = MockUserId1;
+    public Guid CurrentUserId {
+      get { return currentUserId; }
+    }
+
+    public MembershipUser CurrentUser {
+      get { return null; /* todo */ }
+    }
+    
+    public MembershipUser GetUserByName(string username) {
+      return null; // todo
+    }
+
+    public MembershipUser GetUserById(Guid userId) {
+      return null; // todo
+    }
+
+    public void SetUserId(Guid userId) {
+      this.currentUserId = userId;
+    }
+  }
+}
+
+
Index: branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Services.Hive.Tests/ServiceTests.cs
===================================================================
--- branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Services.Hive.Tests/ServiceTests.cs	(revision 6458)
+++ branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Services.Hive.Tests/ServiceTests.cs	(revision 6463)
@@ -303,5 +303,5 @@
     public void TestHiveExperimentPermissions() {
       var service = GetLocalService();
-      mockServiceLocator.SetCurrentUser(MockAuthorizationManager.MockUserId1);
+      mockServiceLocator.SetCurrentUserId(MockUserManager.MockUserId1);
 
       // create hive experiment
@@ -311,13 +311,19 @@
       var e1loaded = service.GetHiveExperiment(e1.Id);
       Assert.AreEqual(Permission.Full, e1loaded.Permission);
-
+      var allExp = service.GetHiveExperiments();
+      Assert.AreEqual(1, allExp.Count(x => x.Id == e1.Id));
+      
       // change to user2
-      mockServiceLocator.SetCurrentUser(MockAuthorizationManager.MockUserId2);
-      e1loaded = service.GetHiveExperiment(e1.Id);
-      Assert.AreEqual(null, e1loaded); // no access
+      mockServiceLocator.SetCurrentUserId(MockUserManager.MockUserId2);
+      try {
+        e1loaded = service.GetHiveExperiment(e1.Id);
+        Assert.Fail("Access should not be possible");
+      } catch { /* ok, cool */ }
+      allExp = service.GetHiveExperiments();
+      Assert.AreEqual(0, allExp.Count(x => x.Id == e1.Id));
 
       // user2 should not be able to grant permissions
       try {
-        service.GrantPermission(e1.Id, MockAuthorizationManager.MockUserId2, Permission.ReadOnly);
+        service.GrantPermission(e1.Id, MockUserManager.MockUserId2, Permission.Read);
         Assert.Fail("Should not be possible to grant permission due to missing permission for User2");
       }
@@ -325,15 +331,17 @@
 
       // switch back to user1 (owner) and grant user2 permissions
-      mockServiceLocator.SetCurrentUser(MockAuthorizationManager.MockUserId1);
-      service.GrantPermission(e1.Id, MockAuthorizationManager.MockUserId2, Permission.ReadOnly);
+      mockServiceLocator.SetCurrentUserId(MockUserManager.MockUserId1);
+      service.GrantPermission(e1.Id, MockUserManager.MockUserId2, Permission.Read);
 
       // back to user2
-      mockServiceLocator.SetCurrentUser(MockAuthorizationManager.MockUserId2);
+      mockServiceLocator.SetCurrentUserId(MockUserManager.MockUserId2);
       e1loaded = service.GetHiveExperiment(e1.Id);
-      Assert.AreEqual(Permission.ReadOnly, e1loaded.Permission);
+      Assert.AreEqual(Permission.Read, e1loaded.Permission);
+      allExp = service.GetHiveExperiments();
+      Assert.AreEqual(1, allExp.Count(x => x.Id == e1.Id));
 
       // user2 should still not be able to grant permissions
       try {
-        service.GrantPermission(e1.Id, MockAuthorizationManager.MockUserId2, Permission.ReadOnly);
+        service.GrantPermission(e1.Id, MockUserManager.MockUserId2, Permission.Read);
         Assert.Fail("Should not be possible to grant permission due to missing permission for User2");
       }
@@ -341,24 +349,33 @@
 
       // back to user1
-      mockServiceLocator.SetCurrentUser(MockAuthorizationManager.MockUserId1);
-      service.GrantPermission(e1.Id, MockAuthorizationManager.MockUserId2, Permission.Full);
+      mockServiceLocator.SetCurrentUserId(MockUserManager.MockUserId1);
+      service.GrantPermission(e1.Id, MockUserManager.MockUserId2, Permission.Full);
 
       // back to user2
-      mockServiceLocator.SetCurrentUser(MockAuthorizationManager.MockUserId2);
+      mockServiceLocator.SetCurrentUserId(MockUserManager.MockUserId2);
       e1loaded = service.GetHiveExperiment(e1.Id);
       Assert.AreEqual(Permission.Full, e1loaded.Permission);
-
+      allExp = service.GetHiveExperiments();
+      Assert.AreEqual(1, allExp.Count(x => x.Id == e1.Id));
+      
       // grant rights to user3, now this should be possible due to full permissions
-      service.GrantPermission(e1.Id, MockAuthorizationManager.MockUserId3, Permission.ReadOnly);
+      service.GrantPermission(e1.Id, MockUserManager.MockUserId3, Permission.Read);
 
       // back to user1 and revoke rights for user2
-      mockServiceLocator.SetCurrentUser(MockAuthorizationManager.MockUserId1);
-      service.RevokePermission(e1.Id, MockAuthorizationManager.MockUserId2);
+      mockServiceLocator.SetCurrentUserId(MockUserManager.MockUserId1);
+      service.RevokePermission(e1.Id, MockUserManager.MockUserId2);
 
       // back to user2
-      mockServiceLocator.SetCurrentUser(MockAuthorizationManager.MockUserId2);
-      e1loaded = service.GetHiveExperiment(e1.Id);
-      Assert.AreEqual(null, e1loaded); // no access
-
+      mockServiceLocator.SetCurrentUserId(MockUserManager.MockUserId2);
+      try {
+        e1loaded = service.GetHiveExperiment(e1.Id);
+        Assert.Fail("Access should not be possible");
+      }
+      catch { /* ok, cool */ }
+      allExp = service.GetHiveExperiments();
+      Assert.AreEqual(0, allExp.Count(x => x.Id == e1.Id));
+
+      // back to user1
+      mockServiceLocator.SetCurrentUserId(MockUserManager.MockUserId1);
       service.DeleteHiveExperiment(e1.Id);
     }
Index: branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Services.Hive/3.4/HeuristicLab.Services.Hive-3.4.csproj
===================================================================
--- branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Services.Hive/3.4/HeuristicLab.Services.Hive-3.4.csproj	(revision 6458)
+++ branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Services.Hive/3.4/HeuristicLab.Services.Hive-3.4.csproj	(revision 6463)
@@ -103,14 +103,16 @@
   </ItemGroup>
   <ItemGroup>
+    <Compile Include="Interfaces\IUserManager.cs" />
+    <Compile Include="Manager\UserManager.cs" />
     <None Include="HeuristicLabServicesHivePlugin.cs.frame" />
     <None Include="Properties\AssemblyInfo.cs.frame" />
-    <Compile Include="AuthenticationManager.cs" />
-    <Compile Include="HeartbeatManager.cs" />
+    <Compile Include="Manager\AuthenticationManager.cs" />
+    <Compile Include="Manager\HeartbeatManager.cs" />
     <Compile Include="Interfaces\IAuthenticationManager.cs" />
     <Compile Include="Interfaces\ILifecycleManager.cs" />
     <Compile Include="Interfaces\IServiceLocator.cs" />
-    <Compile Include="AuthorizationManager.cs" />
+    <Compile Include="Manager\AuthorizationManager.cs" />
     <Compile Include="HeuristicLabServicesHivePlugin.cs" />
-    <Compile Include="LifecycleManager.cs" />
+    <Compile Include="Manager\LifecycleManager.cs" />
     <Compile Include="HiveRoles.cs" />
     <Compile Include="HiveService.cs" />
